CMSIS-DSP: Vector Subtraction

| CMSIS-DSP Version 1.7.0 CMSIS DSP Software Library

- Main Page
- Usage and Description
- Reference

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Functions
Vector Subtraction
Basic Math Functions

## Functions
void | arm_sub_f32 (const float32_t *pSrcA, const float32_t *pSrcB, float32_t *pDst, uint32_t blockSize)
| Floating-point vector subtraction. More...
void | arm_sub_q15 (const q15_t *pSrcA, const q15_t *pSrcB, q15_t *pDst, uint32_t blockSize)
| Q15 vector subtraction. More...
void | arm_sub_q31 (const q31_t *pSrcA, const q31_t *pSrcB, q31_t *pDst, uint32_t blockSize)
| Q31 vector subtraction. More...
void | arm_sub_q7 (const q7_t *pSrcA, const q7_t *pSrcB, q7_t *pDst, uint32_t blockSize)
| Q7 vector subtraction. More...

## Description

Element-by-element subtraction of two vectors.

        pDst[n] = pSrcA[n] - pSrcB[n],   0 <= n < blockSize.

There are separate functions for floating-point, Q7, Q15, and Q31 data types.

## Function Documentation

void arm_sub_f32 | ( | const float32_t * | pSrcA,
|  | const float32_t * | pSrcB,
|  | float32_t * | pDst,
|  | uint32_t | blockSize
| ) |  |

Parameters

  [in] | pSrcA | points to the first input vector
  [in] | pSrcB | points to the second input vector
  [out] | pDst | points to the output vector
  [in] | blockSize | number of samples in each vector

Returns
  none

void arm_sub_q15 | ( | const q15_t * | pSrcA,
|  | const q15_t * | pSrcB,
|  | q15_t * | pDst,
|  | uint32_t | blockSize
| ) |  |

Parameters

  [in] | pSrcA | points to the first input vector
  [in] | pSrcB | points to the second input vector
  [out] | pDst | points to the output vector
  [in] | blockSize | number of samples in each vector

Returns
  none

Scaling and Overflow Behavior
  The function uses saturating arithmetic. Results outside of the allowable Q15 range [0x8000 0x7FFF] are saturated.

void arm_sub_q31 | ( | const q31_t * | pSrcA,
|  | const q31_t * | pSrcB,
|  | q31_t * | pDst,
|  | uint32_t | blockSize
| ) |  |

Parameters

  [in] | pSrcA | points to the first input vector
  [in] | pSrcB | points to the second input vector
  [out] | pDst | points to the output vector
  [in] | blockSize | number of samples in each vector

Returns
  none

Scaling and Overflow Behavior
  The function uses saturating arithmetic. Results outside of the allowable Q31 range [0x80000000 0x7FFFFFFF] are saturated.

void arm_sub_q7 | ( | const q7_t * | pSrcA,
|  | const q7_t * | pSrcB,
|  | q7_t * | pDst,
|  | uint32_t | blockSize
| ) |  |

Parameters

  [in] | pSrcA | points to the first input vector
  [in] | pSrcB | points to the second input vector
  [out] | pDst | points to the output vector
  [in] | blockSize | number of samples in each vector

Returns
  none

Scaling and Overflow Behavior
  The function uses saturating arithmetic. Results outside of the allowable Q7 range [0x80 0x7F] will be saturated.